declare namespace FC {
	interface FutureSocietyIdMap {
		FSSupremacist: {noun: "Racial Supremacism", adj: "Supremacist", deco: "Supremacist"};
		FSSubjugationist: {noun: "Racial Subjugationism", adj: "Subjugationist", deco: "Subjugationist"};
		FSGenderRadicalist: {noun: "Gender Radicalism", adj: "Gender Radicalist", deco: "Gender Radicalist"};
		FSGenderFundamentalist: {noun: "Gender Fundamentalism", adj: "Gender Fundamentalist", deco: "Gender Fundamentalist"};
		FSDegradationist: {noun: "Degradationism", adj: "Degradationist", deco: "Degradationist"};
		FSPaternalist: {noun: "Paternalism", adj: "Paternalist", deco: "Paternalist"};
		FSBodyPurist: {noun: "Body Purism", adj: "Body Purist", deco: "Body Purist"};
		FSTransformationFetishist: {noun: "Transformation Fetishism", adj: "Transformation Fetishist", deco: "Transformation Fetishist"};
		FSYouthPreferentialist: {noun: "Youth Preferentialism", adj: "Youth Preferentialist", deco: "Youth Preferentialist"};
		FSMaturityPreferentialist: {noun: "Maturity Preferentialism", adj: "Maturity Preferentialist", deco: "Maturity Preferentialist"};
		FSSlimnessEnthusiast: {noun: "Slimness Enthusiasm", adj: "Slimness Enthusiast", deco: "Slimness Enthusiast"};
		FSAssetExpansionist: {noun: "Asset Expansionism", adj: "Asset Expansionist", deco: "Asset Expansionist"};
		FSPastoralist: {noun: "Pastoralism", adj: "Pastoralist", deco: "Pastoralist"};
		FSCummunism: {noun: "Cummunism", adj: "Cummunist", deco: ""};
		FSPhysicalIdealist: {noun: "Physical Idealism", adj: "Physical Idealist", deco: "Physical Idealist"};
		FSHedonisticDecadence: {noun: "Decadent Hedonism", adj: "Decadent Hedonist", deco: "Hedonistic"};
		FSChattelReligionist: {noun: "Chattel Religionism", adj: "Chattel Religionist", deco: "Chattel Religionist"};
		FSNull: {noun: "Multiculturalism", adj: "Multiculturalist", deco: ""};
		FSIncestFetishist: {noun: "Incest Fetishism", adj: "Incest Fetishist", deco: ""};
		FSRomanRevivalist: {noun: "Roman Revivalism", adj: "Roman Revivalist", deco: "Roman Revivalist"};
		FSNeoImperialist: {noun: "Neo-Imperialism", adj: "Neo-Imperialist", deco: "Neo-Imperialist"};
		FSEgyptianRevivalist: {noun: "Egyptian Revivalism", adj: "Egyptian Revivalist", deco: "Egyptian Revivalist"};
		FSEdoRevivalist: {noun: "Edo Revivalism", adj: "Edo Revivalist", deco: "Edo Revivalist"};
		FSArabianRevivalist: {noun: "Arabian Revivalism", adj: "Arabian Revivalist", deco: "Arabian Revivalist"};
		FSChineseRevivalist: {noun: "Chinese Revivalism", adj: "Chinese Revivalist", deco: "Chinese Revivalist"};
		FSAztecRevivalist: {noun: "Aztec Revivalism", adj: "Aztec Revivalist", deco: "Aztec Revivalist"};
		FSRepopulationFocus: {noun: "Repopulation Focus", adj: "Repopulationist", deco: "Repopulationist"};
		FSRestart: {noun: "Eugenics", adj: "Eugenics", deco: "Eugenics"};
		FSIntellectualDependency: {noun: "Intellectual Dependency", adj: "Intellectual Dependency", deco: "Intellectual Dependency"};
		FSSlaveProfessionalism: {noun: "Slave Professionalism", adj: "Slave Professional", deco: "Slave Professionalism"};
		FSPetiteAdmiration: {noun: "Petite Admiration", adj: "Petite Admiration", deco: "Petite Admiration"};
		FSStatuesqueGlorification: {noun: "Statuesque Glorification", adj: "Statuesque Glorification", deco: "Statuesque Glorification"}
	}

	type FutureSociety = keyof FutureSocietyIdMap;
	type FutureSocietyNoun = FutureSocietyIdMap[keyof FutureSocietyIdMap]["noun"];
	type FutureSocietyAdj = FutureSocietyIdMap[keyof FutureSocietyIdMap]["adj"];
	type FutureSocietyDeco = FutureSocietyIdMap[keyof FutureSocietyIdMap]["deco"] | "standard";

	type FSPolicyValue = number | "unset";

	// direction with respect to the player's arcology
	type ArcologyDirection = "east" | "north" | "northeast" | "northwest" | "south" | "southeast" | "southwest" | "west";

	interface ArcologyState extends Record<FutureSociety, FSPolicyValue> {
		name: string;
		direction: Zeroable<ArcologyDirection>;
		government: string;
		leaderID: number;
		honeymoon: number;
		prosperity: number;
		ownership: number;
		minority: number;
		PCminority: number;
		demandFactor: number;
		FSSupremacistRace: Zeroable<Race>;
		FSSubjugationistRace: Zeroable<Race>;
		embargo: number;
		embargoTarget: Zeroable<ArcologyDirection>;
		influenceTarget: Zeroable<ArcologyDirection>;
		influenceBonus: number;
		CyberEconomic: number;
		CyberEconomicTarget: Zeroable<ArcologyDirection>;
		CyberReputation: number;
		CyberReputationTarget: Zeroable<ArcologyDirection>;
		rival: number;
		FSGenderRadicalistResearch: Bool;
		FSGenderFundamentalistResearch: Bool;
		FSPaternalistResearch: Bool;
		FSDegradationistResearch: Bool;
		FSBodyPuristResearch: Bool;
		FSTransformationFetishistResearch: Bool;
		FSYouthPreferentialistResearch: Bool;
		FSMaturityPreferentialistResearch: Bool;
		FSSlimnessEnthusiastResearch: Bool;
		FSAssetExpansionistResearch: Bool;
		FSPastoralistResearch: Bool;
		FSPhysicalIdealistResearch: Bool;
		FSRepopulationFocusResearch: Bool;
		FSRestartResearch: Bool;
		FSHedonisticDecadenceResearch: Bool;
		FSHedonisticDecadenceDietResearch: Bool;
		FSIntellectualDependencyResearch: Bool;
		FSSlaveProfessionalismResearch: Bool;
		FSPetiteAdmirationResearch: Bool;
		FSStatuesqueGlorificationResearch: Bool;
		FSCummunismResearch: Bool;
		FSIncestFetishistResearch: Bool;
		FSSupremacistDecoration: number;
		FSSubjugationistDecoration: number;
		FSGenderRadicalistDecoration: number;
		FSGenderFundamentalistDecoration: number;
		FSPaternalistDecoration: number;
		FSDegradationistDecoration: number;
		FSBodyPuristDecoration: number;
		FSTransformationFetishistDecoration: number;
		FSYouthPreferentialistDecoration: number;
		FSMaturityPreferentialistDecoration: number;
		FSSlimnessEnthusiastDecoration: number;
		FSAssetExpansionistDecoration: number;
		FSPastoralistDecoration: number;
		FSPhysicalIdealistDecoration: number;
		FSChattelReligionistDecoration: number;
		FSRomanRevivalistDecoration: number;
		FSNeoImperialistDecoration: number;
		FSAztecRevivalistDecoration: number;
		FSEgyptianRevivalistDecoration: number;
		FSEdoRevivalistDecoration: number;
		FSArabianRevivalistDecoration: number;
		FSChineseRevivalistDecoration: number;
		FSRepopulationFocusDecoration: number;
		FSRestartDecoration: number;
		FSHedonisticDecadenceDecoration: number;
		FSIntellectualDependencyDecoration: number;
		FSSlaveProfessionalismDecoration: number;
		FSPetiteAdmirationDecoration: number;
		FSStatuesqueGlorificationDecoration: number;
		FSCummunismDecoration: number;
		FSIncestFetishistDecoration: number;
		FSSupremacistLawME: number;
		FSSupremacistSMR: number;
		FSSubjugationistLawME: number;
		FSSubjugationistSMR: number;
		FSGenderRadicalistLawFuta: number;
		FSGenderRadicalistLawBeauty: number;
		FSGenderFundamentalistLawBimbo: number;
		FSGenderFundamentalistSMR: number;
		FSGenderFundamentalistLawBeauty: number;
		FSPaternalistLaw: number;
		FSPaternalistSMR: Bool;
		FSDegradationistLaw: number;
		FSDegradationistSMR: Bool;
		FSBodyPuristLaw: number;
		FSBodyPuristSMR: Bool;
		FSBodyPuristCatLaw: Bool;
		FSTransformationFetishistSMR: Bool;
		FSYouthPreferentialistLaw: number;
		FSYouthPreferentialistSMR: Bool;
		FSMaturityPreferentialistLaw: number;
		FSMaturityPreferentialistSMR: Bool;
		FSSlimnessEnthusiastSMR: Bool;
		FSSlimnessEnthusiastLaw: number;
		FSAssetExpansionistSMR: Bool;
		FSPastoralistLaw: number;
		FSPastoralistSMR: Bool;
		FSPhysicalIdealistSMR: number;
		FSPhysicalIdealistLaw: number;
		FSPhysicalIdealistStrongFat: number;
		FSChattelReligionistLaw: number;
		FSChattelReligionistSMR: Bool;
		FSChattelReligionistCreed: number;
		FSRomanRevivalistLaw: number;
		FSRomanRevivalistSMR: Bool;
		FSNeoImperialistLaw1: number;
		FSNeoImperialistLaw2: number;
		FSNeoImperialistSMR: number;
		FSAztecRevivalistLaw: number;
		FSAztecRevivalistSMR: Bool;
		FSEgyptianRevivalistLaw: number;
		FSEgyptianRevivalistSMR: Bool;
		FSEdoRevivalistLaw: number;
		FSEdoRevivalistSMR: Bool;
		FSArabianRevivalistLaw: number;
		FSArabianRevivalistSMR: Bool;
		FSChineseRevivalistLaw: number;
		FSChineseRevivalistSMR: Bool;
		FSRepopulationFocusLaw: number;
		FSRepopulationFocusSMR: Bool;
		FSRestartLaw: number;
		FSRestartSMR: Bool;
		FSHedonisticDecadenceLaw: number;
		FSHedonisticDecadenceLaw2: number;
		FSHedonisticDecadenceStrongFat: number;
		FSHedonisticDecadenceSMR: Bool;
		FSIntellectualDependencyLaw: number;
		FSIntellectualDependencyLawBeauty: number;
		FSIntellectualDependencySMR: Bool;
		FSSlaveProfessionalismLaw: number;
		FSSlaveProfessionalismSMR: Bool;
		FSPetiteAdmirationLaw: number;
		FSPetiteAdmirationLaw2: number;
		FSPetiteAdmirationSMR: Bool;
		FSStatuesqueGlorificationLaw: number;
		FSStatuesqueGlorificationLaw2: number;
		FSStatuesqueGlorificationSMR: Bool;
		FSEgyptianRevivalistIncestPolicy: number;
		FSEgyptianRevivalistInterest: number;
		FSRepopulationFocusPregPolicy: number;
		FSRepopulationFocusMilfPolicy: number;
		FSRepopulationFocusInterest: number;
		FSEugenicsChastityPolicy: number;
		FSEugenicsSterilizationPolicy: number;
		FSEugenicsInterest: number;
		childhoodFertilityInducedNCSResearch: Bool;
		hackingEconomic: number;
		hackingEconomicTarget: number;
		hackingReputationTarget: number;
		hackingReputation: number;
	}
}
